package com.exxeta.samples.jsr352.job;

import java.io.File;
import java.util.Properties;

import javax.batch.operations.JobOperator;
import javax.inject.Inject;
import javax.inject.Named;

import org.slf4j.Logger;

@Named
public class ImportJobLauncher {

	public static final String JOB_NAME = "importJob";
	public static final String PARAM_FILE = "input.file";

	private static final long POLL_INTERVAL_MILLIS = 50;

	@Inject
	private Logger logger;
	@Inject
	private JobOperator jobOperator;

	public long createJob(File csvFile) {
        final Properties parameters = new Properties();

        logger.info("Starting import job for file {}.", csvFile.getPath());
        parameters.put(PARAM_FILE, csvFile.getPath());
        return jobOperator.start(JOB_NAME, parameters);
	}
	
	public void awaitTermination(long jobId) throws InterruptedException {
        do {
        	Thread.sleep(POLL_INTERVAL_MILLIS);
        } while (jobOperator.getJobExecution(jobId).getEndTime() == null);
	}
}
